type 'a liste_doublement_chane = Nil | Cellule of 'a cellule_de_liste_doublement_chane
and 'a cellule_de_liste_doublement_chane = {	mutable valeur : 'a ; 
												mutable lien_arrire : 'a liste_doublement_chane ;
												mutable lien_avant : 'a liste_doublement_chane	} ;;
												
type 'a file_d_attente = { 	mutable tte : 'a liste_doublement_chane ; 
							mutable queue : 'a liste_doublement_chane	} ;;
							
let cre_file_d_attente (bidon:'a) =
	let (file:'a file_d_attente) = { tte = Nil ; queue = Nil }
	in
	let ajoute a = 
		let c = Cellule { valeur = a ; lien_arrire = Nil ; lien_avant = file.tte }
		in
		match file.tte with
			  Nil -> file.tte <- c ; file.queue <- c
			| Cellule ct -> ct.lien_arrire <- c ; file.tte <- c
	and extrait () =
		match file.queue with
			  Nil -> raise File_Vide
			| Cellule cq -> match cq.lien_arrire with
					  Nil -> file.tte <- Nil ; file.queue <- Nil ; cq.valeur
					| (Cellule cp) as p -> file.queue <- p ; cp.lien_avant <- Nil ; cq.valeur
	and est_vide () = file.tte = Nil
	and en_liste () =
		let rec listeur = function
			  Nil -> []
			| Cellule c -> c.valeur:: (listeur c.lien_avant)
		in
		listeur file.tte
	in
	(ajoute,extrait,est_vide,en_liste) ;;
